diff --git a/doc/bash.0 b/doc/bash.0
index b61a2f5e..7e4b82df 100644
--- a/doc/bash.0
+++ b/doc/bash.0
@@ -1002,6 +1002,9 @@ PPAARRAAMMEETTEERRSS
               execution trace.  The first character of PPSS44 is replicated  mul-
               tiple  times, as necessary, to indicate multiple levels of indi-
               rection.  The default is ``++ ''.
+       SSHHEELLLL  The full pathname to the shell is kept in this environment vari-
+              able.   If  it is not set when the shell starts, bbaasshh assigns to
+              it the full pathname of the current user's login shell.
        TTIIMMEEFFOORRMMAATT
               The value of this parameter is used as a format string  specify-
               ing  how  the timing information for pipelines prefixed with the
@@ -3933,127 +3936,126 @@ SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
        kkiillll [--ss _s_i_g_s_p_e_c | --nn _s_i_g_n_u_m | --_s_i_g_s_p_e_c] [_p_i_d | _j_o_b_s_p_e_c] ...
        kkiillll --ll [_s_i_g_s_p_e_c | _e_x_i_t___s_t_a_t_u_s]
               Send  the  signal  named  by  _s_i_g_s_p_e_c or _s_i_g_n_u_m to the processes
-              named by _p_i_d or _j_o_b_s_p_e_c.  _s_i_g_s_p_e_c is either a signal  name  such
-              as  SSIIGGKKIILLLL  or  a signal number; _s_i_g_n_u_m is a signal number.  If
-              _s_i_g_s_p_e_c is a signal name, the name may be given with or  without
-              the  SSIIGG  prefix.   If  _s_i_g_s_p_e_c  is not present, then SSIIGGTTEERRMM is
-              assumed.  An argument of --ll lists  the  signal  names.   If  any
-              arguments  are  supplied when --ll is given, the names of the sig-
-              nals corresponding to the arguments are listed, and  the  return
-              status  is 0.  The _e_x_i_t___s_t_a_t_u_s argument to --ll is a number speci-
-              fying either a signal number or the exit  status  of  a  process
-              terminated  by a signal.  kkiillll returns true if at least one sig-
-              nal was successfully sent, or false if an  error  occurs  or  an
-              invalid option is encountered.
+              named by _p_i_d or _j_o_b_s_p_e_c.  _s_i_g_s_p_e_c is either  a  case-insensitive
+              signal  name such as SSIIGGKKIILLLL (with or without the SSIIGG prefix) or
+              a signal number; _s_i_g_n_u_m is a signal number.  If _s_i_g_s_p_e_c  is  not
+              present,  then  SSIIGGTTEERRMM is assumed.  An argument of --ll lists the
+              signal names.  If any arguments are supplied when --ll  is  given,
+              the  names  of  the  signals  corresponding to the arguments are
+              listed, and the return status is 0.  The _e_x_i_t___s_t_a_t_u_s argument to
+              --ll  is  a  number  specifying either a signal number or the exit
+              status of a process terminated by a signal.  kkiillll  returns  true
+              if  at  least  one  signal was successfully sent, or false if an
+              error occurs or an invalid option is encountered.
 
        lleett _a_r_g [_a_r_g ...]
               Each _a_r_g is an arithmetic expression to be evaluated (see AARRIITTHH--
-              MMEETTIICC EEVVAALLUUAATTIIOONN).  If the last _a_r_g evaluates to 0, lleett  returns
+              MMEETTIICC  EEVVAALLUUAATTIIOONN).  If the last _a_r_g evaluates to 0, lleett returns
               1; 0 is returned otherwise.
 
        llooccaall [_o_p_t_i_o_n] [_n_a_m_e[=_v_a_l_u_e] ...]
-              For  each  argument, a local variable named _n_a_m_e is created, and
-              assigned _v_a_l_u_e.  The _o_p_t_i_o_n can be any of the  options  accepted
+              For each argument, a local variable named _n_a_m_e is  created,  and
+              assigned  _v_a_l_u_e.   The _o_p_t_i_o_n can be any of the options accepted
               by ddeeccllaarree.  When llooccaall is used within a function, it causes the
-              variable _n_a_m_e to have a visible scope restricted to  that  func-
+              variable  _n_a_m_e  to have a visible scope restricted to that func-
               tion and its children.  With no operands, llooccaall writes a list of
-              local variables to the standard output.  It is an error  to  use
+              local  variables  to the standard output.  It is an error to use
               llooccaall when not within a function.  The return status is 0 unless
-              llooccaall is used outside a function, an invalid _n_a_m_e  is  supplied,
+              llooccaall  is  used outside a function, an invalid _n_a_m_e is supplied,
               or _n_a_m_e is a readonly variable.
 
        llooggoouutt Exit a login shell.
 
        ppooppdd [-nn] [+_n] [-_n]
-              Removes  entries  from  the directory stack.  With no arguments,
-              removes the top directory from the stack, and performs a  ccdd  to
+              Removes entries from the directory stack.   With  no  arguments,
+              removes  the  top directory from the stack, and performs a ccdd to
               the new top directory.  Arguments, if supplied, have the follow-
               ing meanings:
-              ++_n     Removes the _nth entry counting from the left of the  list
-                     shown  by  ddiirrss, starting with zero.  For example: ``popd
+              ++_n     Removes  the _nth entry counting from the left of the list
+                     shown by ddiirrss, starting with zero.  For  example:  ``popd
                      +0'' removes the first directory, ``popd +1'' the second.
               --_n     Removes the _nth entry counting from the right of the list
-                     shown by ddiirrss, starting with zero.  For  example:  ``popd
-                     -0''  removes the last directory, ``popd -1'' the next to
+                     shown  by  ddiirrss, starting with zero.  For example: ``popd
+                     -0'' removes the last directory, ``popd -1'' the next  to
                      last.
-              --nn     Suppresses the normal change of directory  when  removing
-                     directories  from  the  stack,  so that only the stack is
+              --nn     Suppresses  the  normal change of directory when removing
+                     directories from the stack, so that  only  the  stack  is
                      manipulated.
 
-              If the ppooppdd command is successful, a ddiirrss is performed as  well,
-              and  the  return  status is 0.  ppooppdd returns false if an invalid
+              If  the ppooppdd command is successful, a ddiirrss is performed as well,
+              and the return status is 0.  ppooppdd returns false  if  an  invalid
               option is encountered, the directory stack is empty, a non-exis-
               tent directory stack entry is specified, or the directory change
               fails.
 
        pprriinnttff _f_o_r_m_a_t [_a_r_g_u_m_e_n_t_s]
-              Write the formatted _a_r_g_u_m_e_n_t_s to the standard output  under  the
-              control  of  the _f_o_r_m_a_t.  The _f_o_r_m_a_t is a character string which
-              contains three types of objects:  plain  characters,  which  are
-              simply  copied  to  standard output, character escape sequences,
-              which are converted and copied to the standard output, and  for-
-              mat  specifications,  each  of which causes printing of the next
+              Write  the  formatted _a_r_g_u_m_e_n_t_s to the standard output under the
+              control of the _f_o_r_m_a_t.  The _f_o_r_m_a_t is a character  string  which
+              contains  three  types  of  objects: plain characters, which are
+              simply copied to standard output,  character  escape  sequences,
+              which  are converted and copied to the standard output, and for-
+              mat specifications, each of which causes printing  of  the  next
               successive _a_r_g_u_m_e_n_t.  In addition to the standard _p_r_i_n_t_f(1) for-
-              mats,  %%bb  causes pprriinnttff to expand backslash escape sequences in
-              the corresponding _a_r_g_u_m_e_n_t (except that  \\cc  terminates  output,
+              mats, %%bb causes pprriinnttff to expand backslash escape  sequences  in
+              the  corresponding  _a_r_g_u_m_e_n_t  (except that \\cc terminates output,
               backslashes in \\'', \\"", and \\?? are not removed, and octal escapes
-              beginning with \\00 may contain up to four digits), and %%qq  causes
+              beginning  with \\00 may contain up to four digits), and %%qq causes
               pprriinnttff to output the corresponding _a_r_g_u_m_e_n_t in a format that can
               be reused as shell input.
 
-              The _f_o_r_m_a_t is reused as necessary to consume all  of  the  _a_r_g_u_-
+              The  _f_o_r_m_a_t  is  reused as necessary to consume all of the _a_r_g_u_-
               _m_e_n_t_s.  If the _f_o_r_m_a_t requires more _a_r_g_u_m_e_n_t_s than are supplied,
-              the extra format specifications behave as if  a  zero  value  or
-              null  string,  as  appropriate,  had  been supplied.  The return
+              the  extra  format  specifications  behave as if a zero value or
+              null string, as appropriate,  had  been  supplied.   The  return
               value is zero on success, non-zero on failure.
 
        ppuusshhdd [--nn] [_d_i_r]
        ppuusshhdd [--nn] [+_n] [-_n]
-              Adds a directory to the top of the directory stack,  or  rotates
-              the  stack,  making the new top of the stack the current working
+              Adds  a  directory to the top of the directory stack, or rotates
+              the stack, making the new top of the stack the  current  working
               directory.  With no arguments, exchanges the top two directories
-              and  returns 0, unless the directory stack is empty.  Arguments,
+              and returns 0, unless the directory stack is empty.   Arguments,
               if supplied, have the following meanings:
-              ++_n     Rotates the stack so that  the  _nth  directory  (counting
-                     from  the  left  of the list shown by ddiirrss, starting with
+              ++_n     Rotates  the  stack  so  that the _nth directory (counting
+                     from the left of the list shown by  ddiirrss,  starting  with
                      zero) is at the top.
-              --_n     Rotates the stack so that  the  _nth  directory  (counting
-                     from  the  right of the list shown by ddiirrss, starting with
+              --_n     Rotates  the  stack  so  that the _nth directory (counting
+                     from the right of the list shown by ddiirrss,  starting  with
                      zero) is at the top.
-              --nn     Suppresses the normal change  of  directory  when  adding
-                     directories  to  the  stack,  so  that  only the stack is
+              --nn     Suppresses  the  normal  change  of directory when adding
+                     directories to the stack,  so  that  only  the  stack  is
                      manipulated.
               _d_i_r    Adds _d_i_r to the directory stack at the top, making it the
                      new current working directory.
 
               If the ppuusshhdd command is successful, a ddiirrss is performed as well.
-              If the first form is used, ppuusshhdd returns 0 unless the cd to  _d_i_r
-              fails.   With the second form, ppuusshhdd returns 0 unless the direc-
-              tory stack is empty, a non-existent directory stack  element  is
-              specified,  or the directory change to the specified new current
+              If  the first form is used, ppuusshhdd returns 0 unless the cd to _d_i_r
+              fails.  With the second form, ppuusshhdd returns 0 unless the  direc-
+              tory  stack  is empty, a non-existent directory stack element is
+              specified, or the directory change to the specified new  current
               directory fails.
 
        ppwwdd [--LLPP]
-              Print the absolute pathname of the  current  working  directory.
+              Print  the  absolute  pathname of the current working directory.
               The pathname printed contains no symbolic links if the --PP option
               is supplied or the --oo pphhyyssiiccaall option to the sseett builtin command
-              is  enabled.  If the --LL option is used, the pathname printed may
-              contain symbolic links.  The return status is 0 unless an  error
-              occurs  while  reading  the  name of the current directory or an
+              is enabled.  If the --LL option is used, the pathname printed  may
+              contain  symbolic links.  The return status is 0 unless an error
+              occurs while reading the name of the  current  directory  or  an
               invalid option is supplied.
 
        rreeaadd [--eerrss] [--uu _f_d] [--tt _t_i_m_e_o_u_t] [--aa _a_n_a_m_e] [--pp _p_r_o_m_p_t] [--nn _n_c_h_a_r_s] [--dd
        _d_e_l_i_m] [_n_a_m_e ...]
-              One line is read from the  standard  input,  or  from  the  file
-              descriptor  _f_d supplied as an argument to the --uu option, and the
+              One  line  is  read  from  the  standard input, or from the file
+              descriptor _f_d supplied as an argument to the --uu option, and  the
               first word is assigned to the first _n_a_m_e, the second word to the
-              second  _n_a_m_e, and so on, with leftover words and their interven-
-              ing separators assigned to the last _n_a_m_e.  If  there  are  fewer
+              second _n_a_m_e, and so on, with leftover words and their  interven-
+              ing  separators  assigned  to the last _n_a_m_e.  If there are fewer
               words read from the input stream than names, the remaining names
-              are assigned empty values.  The characters in IIFFSS  are  used  to
-              split  the  line into words.  The backslash character (\\) may be
-              used to remove any special meaning for the next  character  read
-              and  for line continuation.  Options, if supplied, have the fol-
+              are  assigned  empty  values.  The characters in IIFFSS are used to
+              split the line into words.  The backslash character (\\)  may  be
+              used  to  remove any special meaning for the next character read
+              and for line continuation.  Options, if supplied, have the  fol-
               lowing meanings:
               --aa _a_n_a_m_e
                      The words are assigned to sequential indices of the array
@@ -4061,98 +4063,98 @@ SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
                      new  values  are  assigned.   Other  _n_a_m_e  arguments  are
                      ignored.
               --dd _d_e_l_i_m
-                     The  first  character  of  _d_e_l_i_m is used to terminate the
+                     The first character of _d_e_l_i_m is  used  to  terminate  the
                      input line, rather than newline.
               --ee     If the standard input is coming from a terminal, rreeaaddlliinnee
                      (see RREEAADDLLIINNEE above) is used to obtain the line.
               --nn _n_c_h_a_r_s
-                     rreeaadd  returns after reading _n_c_h_a_r_s characters rather than
+                     rreeaadd returns after reading _n_c_h_a_r_s characters rather  than
                      waiting for a complete line of input.
               --pp _p_r_o_m_p_t
                      Display _p_r_o_m_p_t on standard error, without a trailing new-
                      line, before attempting to read any input.  The prompt is
                      displayed only if input is coming from a terminal.
               --rr     Backslash does not act as an escape character.  The back-
-                     slash  is considered to be part of the line.  In particu-
-                     lar, a backslash-newline pair may not be used as  a  line
+                     slash is considered to be part of the line.  In  particu-
+                     lar,  a  backslash-newline pair may not be used as a line
                      continuation.
               --ss     Silent mode.  If input is coming from a terminal, charac-
                      ters are not echoed.
               --tt _t_i_m_e_o_u_t
-                     Cause rreeaadd to time out and return failure if  a  complete
-                     line  of  input is not read within _t_i_m_e_o_u_t seconds.  This
-                     option has no effect if rreeaadd is not  reading  input  from
+                     Cause  rreeaadd  to time out and return failure if a complete
+                     line of input is not read within _t_i_m_e_o_u_t  seconds.   This
+                     option  has  no  effect if rreeaadd is not reading input from
                      the terminal or a pipe.
               --uu _f_d  Read input from file descriptor _f_d.
 
               If no _n_a_m_e_s are supplied, the line read is assigned to the vari-
-              able RREEPPLLYY.  The return code  is  zero,  unless  end-of-file  is
-              encountered,  rreeaadd  times  out, or an invalid file descriptor is
+              able  RREEPPLLYY.   The  return  code  is zero, unless end-of-file is
+              encountered, rreeaadd times out, or an invalid  file  descriptor  is
               supplied as the argument to --uu.
 
        rreeaaddoonnllyy [--aappff] [_n_a_m_e[=_w_o_r_d] ...]
-              The given _n_a_m_e_s are marked readonly; the values of  these  _n_a_m_e_s
-              may  not  be changed by subsequent assignment.  If the --ff option
-              is supplied, the functions corresponding to  the  _n_a_m_e_s  are  so
+              The  given  _n_a_m_e_s are marked readonly; the values of these _n_a_m_e_s
+              may not be changed by subsequent assignment.  If the  --ff  option
+              is  supplied,  the  functions  corresponding to the _n_a_m_e_s are so
               marked.  The --aa option restricts the variables to arrays.  If no
-              _n_a_m_e arguments are given, or if the --pp  option  is  supplied,  a
-              list  of  all  readonly  names is printed.  The --pp option causes
-              output to be displayed in a format that may be reused as  input.
-              If  a variable name is followed by =_w_o_r_d, the value of the vari-
-              able is set to _w_o_r_d.  The return status is 0 unless  an  invalid
-              option  is  encountered,  one  of the _n_a_m_e_s is not a valid shell
+              _n_a_m_e  arguments  are  given,  or if the --pp option is supplied, a
+              list of all readonly names is printed.   The  --pp  option  causes
+              output  to be displayed in a format that may be reused as input.
+              If a variable name is followed by =_w_o_r_d, the value of the  vari-
+              able  is  set to _w_o_r_d.  The return status is 0 unless an invalid
+              option is encountered, one of the _n_a_m_e_s is  not  a  valid  shell
               variable name, or --ff is supplied with a _n_a_m_e that is not a func-
               tion.
 
        rreettuurrnn [_n]
-              Causes  a function to exit with the return value specified by _n.
-              If _n is omitted, the return status is that of the  last  command
-              executed  in the function body.  If used outside a function, but
-              during execution of a script by  the  ..   (ssoouurrccee)  command,  it
+              Causes a function to exit with the return value specified by  _n.
+              If  _n  is omitted, the return status is that of the last command
+              executed in the function body.  If used outside a function,  but
+              during  execution  of  a  script  by the ..  (ssoouurrccee) command, it
               causes the shell to stop executing that script and return either
-              _n or the exit status of the last  command  executed  within  the
-              script  as  the  exit  status  of the script.  If used outside a
-              function and not during execution of a script by ..,  the  return
+              _n  or  the  exit  status of the last command executed within the
+              script as the exit status of the  script.   If  used  outside  a
+              function  and  not during execution of a script by .., the return
               status is false.  Any command associated with the RREETTUURRNN trap is
-              executed before execution resumes after the function or  script.
+              executed  before execution resumes after the function or script.
 
        sseett [----aabbeeffhhkkmmnnppttuuvvxxBBCCHHPP] [--oo _o_p_t_i_o_n] [_a_r_g ...]
-              Without  options,  the name and value of each shell variable are
-              displayed in a format that can be reused as input.   The  output
-              is  sorted  according  to  the current locale.  When options are
-              specified, they set or unset shell  attributes.   Any  arguments
-              remaining  after the options are processed are treated as values
+              Without options, the name and value of each shell  variable  are
+              displayed  in  a format that can be reused as input.  The output
+              is sorted according to the current  locale.   When  options  are
+              specified,  they  set  or unset shell attributes.  Any arguments
+              remaining after the options are processed are treated as  values
               for the positional parameters and are assigned, in order, to $$11,
-              $$22,  ......   $$_n.   Options, if specified, have the following mean-
+              $$22, ......  $$_n.  Options, if specified, have  the  following  mean-
               ings:
-              --aa      Automatically mark variables  and  functions  which  are
-                      modified  or  created  for  export to the environment of
+              --aa      Automatically  mark  variables  and  functions which are
+                      modified or created for export  to  the  environment  of
                       subsequent commands.
-              --bb      Report the status of terminated background jobs  immedi-
+              --bb      Report  the status of terminated background jobs immedi-
                       ately, rather than before the next primary prompt.  This
                       is effective only when job control is enabled.
-              --ee      Exit immediately if a _s_i_m_p_l_e _c_o_m_m_a_n_d (see SSHHEELLLL  GGRRAAMMMMAARR
+              --ee      Exit  immediately if a _s_i_m_p_l_e _c_o_m_m_a_n_d (see SSHHEELLLL GGRRAAMMMMAARR
                       above) exits with a non-zero status.  The shell does not
-                      exit if the command that fails is part  of  the  command
-                      list  immediately  following  a  wwhhiillee or uunnttiill keyword,
-                      part of the test in an _i_f statement, part of a &&&& or  ||||
+                      exit  if  the  command that fails is part of the command
+                      list immediately following a  wwhhiillee  or  uunnttiill  keyword,
+                      part  of the test in an _i_f statement, part of a &&&& or ||||
                       list, or if the command's return value is being inverted
-                      via !!.  A trap on EERRRR, if set, is  executed  before  the
+                      via  !!.   A  trap on EERRRR, if set, is executed before the
                       shell exits.
               --ff      Disable pathname expansion.
-              --hh      Remember  the location of commands as they are looked up
+              --hh      Remember the location of commands as they are looked  up
                       for execution.  This is enabled by default.
-              --kk      All arguments in the form of assignment  statements  are
-                      placed  in the environment for a command, not just those
+              --kk      All  arguments  in the form of assignment statements are
+                      placed in the environment for a command, not just  those
                       that precede the command name.
-              --mm      Monitor mode.  Job control is enabled.  This  option  is
-                      on  by  default  for  interactive shells on systems that
-                      support it (see JJOOBB  CCOONNTTRROOLL  above).   Background  pro-
-                      cesses  run  in a separate process group and a line con-
-                      taining their exit status is printed upon their  comple-
+              --mm      Monitor  mode.   Job control is enabled.  This option is
+                      on by default for interactive  shells  on  systems  that
+                      support  it  (see  JJOOBB  CCOONNTTRROOLL above).  Background pro-
+                      cesses run in a separate process group and a  line  con-
+                      taining  their exit status is printed upon their comple-
                       tion.
               --nn      Read commands but do not execute them.  This may be used
-                      to check a shell script  for  syntax  errors.   This  is
+                      to  check  a  shell  script  for syntax errors.  This is
                       ignored by interactive shells.
               --oo _o_p_t_i_o_n_-_n_a_m_e
                       The _o_p_t_i_o_n_-_n_a_m_e can be one of the following:
@@ -4160,7 +4162,7 @@ SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
                               Same as --aa.
                       bbrraacceeeexxppaanndd
                               Same as --BB.
-                      eemmaaccss   Use  an  emacs-style command line editing inter-
+                      eemmaaccss   Use an emacs-style command line  editing  inter-
                               face.  This is enabled by default when the shell
                               is interactive, unless the shell is started with
                               the ----nnooeeddiittiinngg option.
@@ -4176,8 +4178,8 @@ SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
                               HHIISSTTOORRYY.  This option is on by default in inter-
                               active shells.
                       iiggnnoorreeeeooff
-                              The  effect  is  as   if   the   shell   command
-                              ``IGNOREEOF=10''  had  been  executed (see SShheellll
+                              The   effect   is   as   if  the  shell  command
+                              ``IGNOREEOF=10'' had been  executed  (see  SShheellll
                               VVaarriiaabblleess above).
                       kkeeyywwoorrdd Same as --kk.
                       mmoonniittoorr Same as --mm.
@@ -4191,12 +4193,12 @@ SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
                       pphhyyssiiccaall
                               Same as --PP.
                       ppiippeeffaaiill
-                              If set, the return value of a  pipeline  is  the
-                              value  of  the  last (rightmost) command to exit
-                              with a non-zero status, or zero if all  commands
-                              in  the pipeline exit successfully.  This option
+                              If  set,  the  return value of a pipeline is the
+                              value of the last (rightmost)  command  to  exit
+                              with  a non-zero status, or zero if all commands
+                              in the pipeline exit successfully.  This  option
                               is disabled by default.
-                      ppoossiixx   Change the behavior of bbaasshh  where  the  default
+                      ppoossiixx   Change  the  behavior  of bbaasshh where the default
                               operation differs from the POSIX 1003.2 standard
                               to match the standard (_`_p_o_s_i_x _m_o_d_e).
                       pprriivviilleeggeedd
